@Library('jenkins-shred-lib@master') _

pipeline {
    agent any
    environment {
        app_deploy_path="/opt/tomcat8"
       
       }
	stages {
        stage('checkout git') {
            steps {
                gitCheckout(
                branch: "master",
                url: "https://gitlab.com/ajay.panwar/tomcat-installation.git"
            )
            }
        }

        stage('Build') {
            steps {
                sh 'mvn -Dmaven.test.failure.ignore=true install'
            }
        }

        stage ('Testing') {
            steps {
                parallel (
                    "Checkstyle Test": { sh 'mvn checkstyle:checkstyle'
								echo 'Checkstyle test Completed' },
                    "PMD Test": { sh 'mvn pmd:pmd'
               			 		echo 'PMD test Completed' },
                    "Findbugs Test": { sh 'mvn findbugs:findbugs'
                				echo "Findbugs Analysis test Completed" },
                	"Cobertura Test": { sh 'mvn cobertura:cobertura'
                				echo 'Cobertura Analysis test Completed' }
                )
            }
        }

        stage('deploy .war file to tomcat'){
            steps {
               deployApp(app_deploy_path)
            }
        }
    
        stage('Email_Sent') {
            steps {
                 // Mail for successful Excution.
                
            mail bcc: '', 
            body: 'Your build is successful.', 
            cc: '', from: '', 
            replyTo: '', 
            subject: 'Tomcat App Deployed Successfully', 
            to: 'ajay.3ginfo@gmail.com'
            }
        }
    }

}